%% Simulation parameters

SIM_START_TIME      = 0;
SIM_STOP_TIME       = 300;
SIM_STEP_SIZE       = 0.25;

set_param('top_model','StartTime',num2str(SIM_START_TIME))
set_param('top_model','StopTime',num2str(SIM_STOP_TIME))
set_param('top_model','FixedStep',num2str(SIM_STEP_SIZE))

% Set perturbing torques (0/1)
SET_tau_eb = 1;

% Set time delays
SET_DELAY   = 1;                    % (0/1) 
DELAY       = SIM_STEP_SIZE*1;      % Total delay in system

% Measurement noise. Value above 0 sets the noise.
ENABLE_NOISE = 1;

JITTERING           = 1*ENABLE_NOISE;
W_IB_NOISE          = 1*ENABLE_NOISE;
QUATERNION_NOISE    = 1*ENABLE_NOISE;


Q_NOISE_SAMPLE_TIME     = SIM_STEP_SIZE;
Q_NOISE_VARIANCE        = deg2rad(0.01);%1.7453e-04;
Q_NOISE_SEED_1          = 1;
Q_NOISE_SEED_2          = 2;
Q_NOISE_SEED_3          = 3;

W_IB_NOISE_SAMPLE_TIME  = SIM_STEP_SIZE;
W_IB_NOISE_VARIANCE     = 1e-5*1e-2;%deg2rad(0.4);%
W_IB_NOISE_SEED_1       = 4;
W_IB_NOISE_SEED_2       = 5;
W_IB_NOISE_SEED_3       = 6;


JITTERING_SAMPLE_TIME   = SIM_STEP_SIZE;
JITTERING_VARIANCE      = sqrt(30/RPMtorad);
JITTERING_SEED_1        = 7;
JITTERING_SEED_2        = 8;
JITTERING_SEED_3        = 9;