%% HYPSO reaction wheel control gains

% Motor controller
%MC_P = eye(n_wheels);
%MC_I = 1e-3*eye(n_wheels);

% PD control
% No perturbations: 
Kp_w    = J_s./1000;
Kd_w    = J_s*45./1000;

% With disturbance gravitational gradient and atmospheric drag:
Kp_w    = J_s*10./1000;
Kd_w    = J_s*45*10./1000;

% With all perturbations:
Kp_w    = J_s*10./1000;
Kd_w    = J_s*45*10./1000;
K_point = [Kp_w, Kd_w];


% SMC 1st order gains
K_surf  = 0.5*eye(3);%J_s./10;%J_s./1000; % Pointing: bare ./10 her
P       = J_s./1000;%J_s./1000;
D       = J_s./1000;%J_s./1000;

% GSTA gains
K_GSTA      = 0.5*eye(3)./10;
k1_GSTA     = 5*ones(3,1)./1e3;%5*ones(3,1)./1e4;
k2_GSTA     = 0.0002*ones(3,1)./1e4;%0.0002*ones(3,1)./1e6;
beta_GSTA   = 15*ones(3,1)./1e2;%15*ones(3,1)./1e5;


% k1_GSTA     = k1_GSTA;
% k2_GSTA     = k2_GSTA;
% beta_GSTA   = beta_GSTA;

% % To test 4x1 quaternion
% k1_GSTA     = 5*ones(4,1)./1e3;%5*ones(3,1)./1e4;
% k2_GSTA     = 0.0002*ones(4,1)./1e4;%0.0002*ones(3,1)./1e6;
% beta_GSTA   = 15*ones(4,1)./1e2;%15*ones(3,1)./1e5;



% LQR
x1_LQR      = w_bww_init;%zeros(n_wheels,1); % omega_bw^w
x2_LQR      = zeros(3,1); % omega_ib^b
% x2_LQR(2)   = 3e-3;
x3_LQR      = ones(1,1); % eta
x4_LQR      = zeros(3,1); % epsilon

omega_iob   = [0;0;0];%[0;0;1e-7]; % Complete guess

% Full linearized model, not in use for the LQR
A_LQR = [A_pinv*J_s_inv*skewSym(x2_LQR)*A*J_w, A_pinv*J_s_inv*(skewSym(x2_LQR)*J-skewSym(J*x2_LQR)-skewSym(A*J_w*x1_LQR)), zeros(n_wheels,1), zeros(n_wheels,3);
    -J_s_inv*skewSym(x2_LQR)*A*J_w, -J_s_inv*(skewSym(x2_LQR)*J-skewSym(J*x2_LQR)-skewSym(A*J_w*x1_LQR)), zeros(3,1), zeros(3,3);
    zeros(1,n_wheels), -0.5*x4_LQR', zeros(1,1), -0.5*x2_LQR';
    zeros(3,n_wheels), 0.5*(x3_LQR*eye(3)+skewSym(x4_LQR)), 0.5*(x2_LQR-omega_iob), 0.5*skewSym(x2_LQR-omega_iob)];

B_LQR = [J_w_inv + A_pinv*J_s_inv*A, -A_pinv*J_s_inv, zeros(n_wheels,3);
    -J_s_inv*A, J_s_inv, J_s_inv;
    zeros(1,n_wheels),zeros(1,3),zeros(1,3);
    zeros(3,n_wheels), zeros(3,3), zeros(3,3)];

% Only w_ibb, epsilon
A_LQR = [-J_s_inv*(skewSym(x2_LQR)*J-skewSym(J*x2_LQR)-skewSym(A_nom*J_w*x1_LQR)), zeros(3,3);
   0.5*(x3_LQR*eye(3)+skewSym(x4_LQR)), 0.5*skewSym(x2_LQR-omega_iob)];

B_LQR = [-J_s_inv;
    zeros(3,3)];



[~,mA_LQR]  = size(A_LQR);
[~,mB_LQR]  = size(B_LQR);

Q_LQR       = diag(diag(ones(mA_LQR)));
R_LQR       = diag(diag(ones(mB_LQR)));
N_LQR       = zeros(mA_LQR, mB_LQR);

[K_LQR,~, ~] = lqr(A_LQR, B_LQR, Q_LQR, R_LQR, N_LQR);

% Check if controllable: length(A_LQR)-rank(ctrb(A_LQR, B_LQR))