function varout = kepler2eci(a,e,i,omega,RA,theta,mu)
%https://space.stackexchange.com/questions/19322/converting-orbital-elements-to-cartesian-state-vectors
% In the doc from the first answer here, kep2cart_2002

%3
%theta = 2*atan(sqrt((1+e)/(1-e)) * tan(EA/2))
EA = 2*atan(tan(theta/2) / sqrt((1+e)/(1-e)));
%4
r = a*(1 - e*cos(EA));
%5
h = sqrt(mu*a * (1 - e^2));
%6
Om = RA;%omega_LAN;
w =  omega;%omega_AP;

X = r*(cos(Om)*cos(w+theta) - sin(Om)*sin(w+theta)*cos(i));
Y = r*(sin(Om)*cos(w+theta) + cos(Om)*sin(w+theta)*cos(i));
Z = r*(sin(i)*sin(w+theta));

%7
p = a*(1-e^2);

V_X = (X*h*e/(r*p))*sin(theta) - (h/r)*(cos(Om)*sin(w+theta) + sin(Om)*cos(w+theta)*cos(i));
V_Y = (Y*h*e/(r*p))*sin(theta) - (h/r)*(sin(Om)*sin(w+theta) - cos(Om)*cos(w+theta)*cos(i));
V_Z = (Z*h*e/(r*p))*sin(theta) - (h/r)*(cos(w+theta)*sin(i));


r_out = [X,Y,Z];
v_out = [V_X,V_Y,V_Z];

varout = [r_out'; v_out'];


end