function plot_orbit_complete(position, Re)
figure(1)
set(gcf,'units','normalized','outerposition',[0 0 1 1])
% https://se.mathworks.com/matlabcentral/answers/44378-plotting-3d-sphere-with-specific-radius
[x,y,z] = sphere;
surf(x*Re, y*Re, z*Re);

axis equal;


position
pos_len = length(position.time);

all_orbit_points = getdatasamples(position,(1:pos_len));
[Xmax, ~] = max(all_orbit_points(:,1));
[Xmin, ~] = min(all_orbit_points(:,1));
[Ymax, ~] = max(all_orbit_points(:,2));
[Ymin, ~] = min(all_orbit_points(:,2));
[Zmax, ~] = max(all_orbit_points(:,3));
[Zmin, ~] = min(all_orbit_points(:,3));

minst = min([Xmin Ymin Zmin]);
maks = max([Xmax Ymax Zmax]);

[Xmin, Ymin, Zmin] = deal(minst, minst, minst);
[Xmax, Ymax, Zmax] = deal(maks, maks, maks);

ax = gca;
ax.XLim = [Xmin Xmax]*1.1;
ax.YLim = [Ymin Ymax]*1.1;
ax.ZLim = [Zmin Zmax]*1.1;


alpha('clear') % making sphere clear for visualization
hold on

to_plot = getdatasamples(position,(1:pos_len));

figure(1);
%h = plot3(to_plot(:,1), to_plot(:,2), to_plot(:,3), 'g', to_plot(pos_len,1), to_plot(pos_len,2), to_plot(pos_len,3), 'r-o', 'LineWidth', 2);
comet3(to_plot(:,1),to_plot(:,2),to_plot(:,3));
ax = gca;
ax.XLim = [Xmin Xmax];
ax.YLim = [Ymin Ymax];
ax.ZLim = [Zmin Zmax];
pause(0.00001);

end