function plot_orbit_tail(position, Re, test_length, skip_step, min_tail, wanted_steps)

% https://se.mathworks.com/matlabcentral/answers/411782-how-to-have-a-plot3-vector-and-sphere-on-same-figure
figure(1)
set(gcf,'units','normalized','outerposition',[0 0 1 1])
% https://se.mathworks.com/matlabcentral/answers/44378-plotting-3d-sphere-with-specific-radius
[x,y,z] = sphere;
surf(x*Re, y*Re, z*Re);

axis equal;

position
pos_len = length(position.time);

step_pos = int32(1);
%test_length = 810;%350;

if pos_len < test_length
    all_orbit_points = getdatasamples(position,(1:pos_len));
else
    shortened = getsamples(position,(1:skip_step:pos_len));
    all_orbit_points = getdatasamples(shortened,(1:length(shortened.time)));
    step_pos = int32(skip_step);
end

[Xmax, ~] = max(all_orbit_points(:,1));
[Xmin, ~] = min(all_orbit_points(:,1));
[Ymax, ~] = max(all_orbit_points(:,2));
[Ymin, ~] = min(all_orbit_points(:,2));
[Zmax, ~] = max(all_orbit_points(:,3));
[Zmin, ~] = min(all_orbit_points(:,3));

minst = min([Xmin Ymin Zmin]);
maks = max([Xmax Ymax Zmax]);

[Xmin, Ymin, Zmin] = deal(minst, minst, minst);
[Xmax, Ymax, Zmax] = deal(maks, maks, maks);

ax = gca;
ax.XLim = [Xmin Xmax]*1.1;
ax.YLim = [Ymin Ymax]*1.1;
ax.ZLim = [Zmin Zmax]*1.1;


alpha('clear') % making sphere clear for visualization
hold on
for i = 1:idivide(pos_len, step_pos)
    % Get each of the plotted components
    children = get(gca, 'children');

    % If there is only one, this is the first iteration, so do nothing.  Otherwise, remove the line
    if length(children)>1
        delete(children(1));
    end

    if mod(i,1000)==0
        disp(i)
    end

    %
    pos_len = length(position.time);

    step_pos = int32(1);

    if pos_len < test_length
        tail = max(min_tail, idivide(pos_len, int32(wanted_steps)));
        to_plot = getdatasamples(position,(max(1,i-tail):i));
    else            
        tail = max(min_tail, idivide(length(shortened.time), int32(wanted_steps)));
        to_plot = getdatasamples(shortened,(max(1,i-tail):i));
    end
    %

    %tail = max(30, idivide(pos_len, int32(wanted_steps)));

    %to_plot = getdatasamples(position,(max(1,i-tail):step_pos:i));
    figure(1);
    %sat_marker_index = min(i,min_tail);

    test = exist('h','var');
    if test
        delete(h)
    end
    h = plot3(to_plot(:,1), to_plot(:,2), to_plot(:,3), 'g', to_plot(end,1), to_plot(end,2), to_plot(end,3), 'r-o', 'LineWidth', 2);
    ax = gca;
    ax.XLim = [Xmin Xmax];
    ax.YLim = [Ymin Ymax];
    ax.ZLim = [Zmin Zmax];
    pause(0.00001);
end 
end